claw::dynamic_library_traits_unix Class Reference

Unix interface for using dynamic libraries. More...

`#include <dynamic_library_traits_unix.hpp>`

## Public Types

typedef void * | handle
| Type of the system handle to the library.

## Static Public Member Functions

static handle | open (const std::string &name)
| Open a library.
static handle | auto_open (const std::string &name)
| Open the current program.
static void | close (handle h)
| Close a library.
template<class T>
static T | get_symbol (handle h, const std::string &name)
| Get a symbol from a library.
static bool | have_symbol (handle h, const std::string &name)
| Tell if a symbol is in the library.
static bool | valid_handle (handle h)
| Tell if an handle is a valid library handle.

## Detailed Description

Unix interface for using dynamic libraries.

Author
  Julien Jorge

Definition at line 43 of file dynamic_library_traits_unix.hpp.

## Member Typedef Documentation

## handle

typedef void* claw::dynamic_library_traits_unix::handle

Type of the system handle to the library.

Definition at line 47 of file dynamic_library_traits_unix.hpp.

## Member Function Documentation

## auto_open()

handle claw::dynamic_library_traits_unix::auto_open | ( | const std::string & | name | ) |

inline static

Open the current program.

Parameters

  name | (not used) The name of the current program.

Returns
  The handle on the loaded library.

Definition at line 72 of file dynamic_library_traits_unix.hpp.

References valid_handle().

Referenced by claw::dynamic_library::dynamic_library().

## close()

void claw::dynamic_library_traits_unix::close | ( | handle | h | ) |

inline static

Close a library.

Parameters

  h | The handle of the library to close.

Definition at line 87 of file dynamic_library_traits_unix.hpp.

Referenced by claw::dynamic_library::~dynamic_library().

## get_symbol()

template<class T>

T claw::dynamic_library_traits_unix::get_symbol | ( | handle | h,
|  | const std::string & | name )

inline static

Get a symbol from a library.

Parameters

  h | Handle of the library.
  name | The name of the symbol to load.

Definition at line 99 of file dynamic_library_traits_unix.hpp.

## have_symbol()

bool claw::dynamic_library_traits_unix::have_symbol | ( | handle | h,
|  | const std::string & | name )

inline static

Tell if a symbol is in the library.

Parameters

  h | Handle of the library.
  name | The name of the symbol to find.

Definition at line 115 of file dynamic_library_traits_unix.hpp.

Referenced by claw::dynamic_library::have_symbol().

## open()

handle claw::dynamic_library_traits_unix::open | ( | const std::string & | name | ) |

inline static

Open a library.

Parameters

  name | The name of the library to open.

Returns
  The handle on the loaded library.

Definition at line 56 of file dynamic_library_traits_unix.hpp.

References valid_handle().

Referenced by claw::dynamic_library::dynamic_library().

## valid_handle()

bool claw::dynamic_library_traits_unix::valid_handle | ( | handle | h | ) |

inline static

Tell if an handle is a valid library handle.

Parameters

  h | The handle to test.

Definition at line 125 of file dynamic_library_traits_unix.hpp.

Referenced by auto_open(), claw::dynamic_library::dynamic_library(), and open().

The documentation for this class was generated from the following file:

- dynamic_library_traits_unix.hpp